package hanoi;

public class Hanoi {
	
	private int zug = 0 ;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		int hoehe = Integer.parseInt(args[0]) ;
		Hanoi hanoi = new Hanoi(hoehe);
	}
	
	
	public Hanoi(int hoehe) {
		System.out.println("Anfang des Projekts ");
	    bewegeTurm(hoehe, PositionHanoi.LEFT, PositionHanoi.RIGHT);
		System.out.println("Für eine Höhe von " + hoehe + " wurden " + zug + "Züge benötigt");
	}



	public void bewegeTurm(int hoehe, PositionHanoi start, PositionHanoi end){
		if (hoehe == 1){
		   this.bewegeStein(start, end);
		}else{
			PositionHanoi zwischen = this.getZwischenposition(start, end);
			bewegeTurm(hoehe-1, start, zwischen);
			bewegeStein(start, end);
			bewegeTurm(hoehe-1, zwischen, end);			
		}
	}
	
	private void bewegeStein(PositionHanoi start, PositionHanoi end){
		zug = zug + 1 ;
		System.out.println("Zug: " + zug + " Bewege Stein von Position " + start.getNumber() + " nach Position " + end.getNumber());
	}
	
	private PositionHanoi getZwischenposition(PositionHanoi start, PositionHanoi end){
        if (start.getName().equalsIgnoreCase("Left") && end.getName().equalsIgnoreCase("Middle")) return PositionHanoi.RIGHT ;
        if (start.getName().equalsIgnoreCase("Left") && end.getName().equalsIgnoreCase("Right")) return PositionHanoi.MIDDLE ;  
        
        if (start.getName().equalsIgnoreCase("Middle") && end.getName().equalsIgnoreCase("Left")) return PositionHanoi.RIGHT ;
        if (start.getName().equalsIgnoreCase("Middle") && end.getName().equalsIgnoreCase("Right")) return PositionHanoi.LEFT ;
        
        if (start.getName().equalsIgnoreCase("Right") && end.getName().equalsIgnoreCase("Left")) return PositionHanoi.MIDDLE ;
        if (start.getName().equalsIgnoreCase("Right") && end.getName().equalsIgnoreCase("Middle")) return PositionHanoi.LEFT ;       
		return null ;
	}

}
